// 所有的发音人
var mSpeakerArray = new Array();

var WOMAN = "woman";
var MAN = "man";
var ENGLISH_LANGUAGE = "en_us";

var SPEAKER_XIAOYAN = "xiaoyan";

function Speaker(name,nickname,id,sex,age,accent,accent_cn,language,vercode,ttsResourceId,listenResourceId,tts_text,icon_name,bg_name,image_bright_name,image_gray_name)
{
	
	this.name = name;           // 以name做唯一标示
	this.nickname = nickname;
	this.id = id;
	this.sex = sex;
	this.age = age;
	this.accent = accent;
	this.accent_cn = accent_cn;
	this.language = language;
	this.vercode = vercode;
		
	this.ttsResourceId = ttsResourceId;
	this.listenResourceId = listenResourceId;
	this.tts_text = tts_text;
	
	// icon和image的名字
	this.icon_name = icon_name;
	this.bg_name = bg_name;
	this.image_bright_name = image_bright_name;
	this.image_gray_name = image_gray_name;
	
	// 下载进度的显示需要用到
	this.image_height;
}

function loadSpeakerData(data_path)
{
	$.ajaxSettings.async = false; 
	$.getJSON(data_path,function(data)
	{
		var speaker;
		$.each(data,function(index,jsonObject){
			speaker = new Speaker(jsonObject.name,jsonObject.nickname,jsonObject.id
			,jsonObject.sex,jsonObject.age,jsonObject.accent,jsonObject.accent_cn,jsonObject.language
			,jsonObject.vercode,jsonObject.ttsResourceId,jsonObject.listenResourceId,jsonObject.tts_text
			,jsonObject.icon_name,jsonObject.bg_name,jsonObject.image_bright_name,jsonObject.image_gray_name);
			
			mSpeakerArray[index] = speaker;
		})
	})
}

// 添加发音人到html中
function addSpeakerToHtml()
{
	// 拼接html
	var html = '';
	
	var length = mSpeakerArray.length;
	for(var i=0; i<length; i++)
	{
		
		html += '<div class="swiper-slide"><div class="speaker_icon"><img class="icon" name="' 
		+ mSpeakerArray[i].icon_name + '"><div class="speaker_accent">' + mSpeakerArray[i].accent_cn 
		+ '</div><div class="icon_divide"></div><div class="opacity_layer"></div></div></div>';
	}
	
	$('.thumbs-container .swiper-wrapper').append(html);
}

function createSpeaker(data_path)
{
	loadSpeakerData(data_path);
	addSpeakerToHtml();
	
	return mSpeakerArray.length;
}

function getSpeakerByName(name)
{
	var length = mSpeakerArray.length;
	for(var i=0; i<length; i++)
	{
		if(name === mSpeakerArray[i].name)
		{
			return mSpeakerArray[i];
		}
	}
	return null;
}

function getSpeakerByIndex(index)
{
	return mSpeakerArray[(index + mSpeakerArray.length) % mSpeakerArray.length];
}

function getSpeakerNameByIndex(index)
{
	var speaker = getSpeakerByIndex(index);
	return speaker.name;
}
function isEnglishSpeaker(language)
{
	if(ENGLISH_LANGUAGE === language)
		return true;
	return false;
}